#!/bin/csh
# this script illustrates how everything works

# change incr to get higher-definition images (becomes slower)
set incr = 5
# conversion from generalized harmonic coefficients to xyz files
# isotropic
gsh2xyz<<EOF
animodel.r100.0
$incr
1
40
EOF
# 2phi
gsh2xyz<<EOF
animodel.r100.2
$incr
1
20
EOF
# 4phi
gsh2xyz<<EOF
animodel.r100.4
$incr
1
20
EOF


#
#find fast 2psi or 4psi direction, and azimuthal anisotropy variation
#amplitude, over a grid, from gridded alpha_i files
#
xyz2aniso<<EOF
2
animodel.r100.2.xyz
2
EOF

xyz2aniso<<EOF
4
animodel.r100.4.xyz
2
EOF
# use GMT to plot isotropic anomalies
./mapview.csh animodel.r100.0.eps0.040.xyz $incr
# use GMT to plot 2psi fast directions
./plotaniso2.csh animodel.r100.2.xyz.2.x animodel.r100.2.xyz.2.y $incr
# use GMT to plot 4psi fast directions
./plotaniso4.csh animodel.r100.4.xyz.4.x animodel.r100.4.xyz.4.y animodel.r100.4.xyz.4.x2 animodel.r100.4.xyz.4.y2 $incr
# compare the resulting .ps file with those of Boschi and Woodhouse 2006.
