    program testylmv4
      implicit none

      double precision, allocatable, dimension(:) :: d, rnorm
      double precision, allocatable, dimension(:,:,:,:,:) :: u
      double precision, allocatable, dimension(:,:) :: ints
      double precision zeta,toradians
      double precision nu(2)
      real*4, allocatable, dimension(:) :: y,ypp,ytp,ypppp,ytppp
      real*4 xlat, xlon
      integer lmax0,lmax2,lmax4,lmax,nmdl0,nmdl2,nmdl4,nmdl
      integer ndeg,i,j,k,imdl,imdlv,imdlu,iy,l,m,ic,ivmax,iumax
      double precision test1,test2,cos2zeta,sin2zeta,cos4zeta,sin4zeta,dtheta,dphi,theta,sintheta,offmax
      double precision dot4, dot4nu
      

      toradians=atan(1.)/45.d0
      zeta=37.d0*toradians     ! arbitrarily chosen zeta for testing
      nu(1)=-sin(zeta)
      nu(2)= cos(zeta)
      cos2zeta=cos(2*zeta)
      sin2zeta=sin(2*zeta)
      cos4zeta=cos(4*zeta)
      sin4zeta=sin(4*zeta)

      lmax0=6
      lmax2=6
      lmax4=6
      lmax=max(lmax0,lmax2,lmax4)
      nmdl0=(lmax0+1)**2
      nmdl2=max(0,(lmax2-1)*(2*lmax2+6))
      nmdl4=max(0,(lmax4-3)*(2*lmax4+10))
      nmdl=nmdl0+nmdl2+nmdl4
      print *,'Model vector for degree (',lmax0,',',lmax2,',',lmax4, &
     &    ')  is of length',nmdl0,' +',nmdl2,' +',nmdl4,' =',nmdl

      allocate(y(nmdl0),ypp(nmdl2),ytp(nmdl2),ypppp(nmdl4),ytppp(nmdl4),d(9*(2*lmax+1)),u(2,2,2,2,nmdl),rnorm(nmdl))

      allocate(ints(nmdl,nmdl))

! construct the vector of normalization constants
      imdl=0
      do l=0,lmax0
        do m=0,l
          if(m == 0) then
            imdl=imdl+1
            rnorm(imdl)=1.d0
          else
            do ic=1,2
              imdl=imdl+1
              rnorm(imdl)=sqrt(1./2.d0)
            enddo
          endif
        enddo
      enddo
      do l=2,lmax2
        do m=0,l
          if(m == 0) then
            do ic=1,2
              imdl=imdl+1
              rnorm(imdl)=sqrt(3./4.d0)
            enddo
          else
            do ic=1,4
              imdl=imdl+1
              rnorm(imdl)=sqrt(3./4.d0)
            enddo
          endif
        enddo
      enddo
      do l=4,lmax4
        do m=0,l
          if(m == 0) then
            do ic=1,2
              imdl=imdl+1
              rnorm(imdl)=sqrt(3.d0)
            enddo
          else
            do ic=1,4
              imdl=imdl+1
              rnorm(imdl)=sqrt(3.d0)
            enddo
          endif
        enddo
      enddo

      if(imdl /= nmdl) stop 'wrong count of model parameters'

       





      ndeg=5   ! lat lon increment for integration in degrees. Should be a divisor of 180.

      

      dtheta=ndeg*toradians
      dphi=dtheta
      ints=0

      do i=0,180/ndeg-1
      do j=0,360/ndeg-1
        xlat=90-(ndeg/2.0+i*ndeg)
        xlon=ndeg/2.0+j*ndeg
        theta=(90.-xlat)*toradians
        sintheta=sin(theta)
        call ylmv4(xlat,xlon,lmax,y,ypp,ytp,ypppp,ytppp,d)
        imdl=0
!       construct the 4th rank tensor corresponding to each model coefficient
!       0-psi terms
        iy=0
        do k=1,nmdl0
          imdl=imdl+1
          iy=iy+1
          u(1,1,1,1,imdl)=y(iy)
          u(1,1,1,2,imdl)=0.
          u(1,1,2,2,imdl)=(1./3.)*y(iy)
          u(1,2,2,2,imdl)=0.
          u(2,2,2,2,imdl)=y(iy)
          call symfill(u(1,1,1,1,imdl))

!         u.nu.nu.nu.nu should be equal to y(iy)

          test1=y(iy)
          test2=dot4nu(u(1,1,1,1,imdl),nu)
          if(abs(test1-test2) > 1.d-7) print *,'****iy,test1,test2 A:',iy,test1,test2
        enddo
!       2-psi terms
        iy=0
        do k=1,nmdl2
          imdl=imdl+1
          iy=iy+1
          u(1,1,1,1,imdl)= -ypp(iy)
          u(1,1,1,2,imdl)= (1./2.)*ytp(iy)
          u(1,1,2,2,imdl)= 0.
          u(1,2,2,2,imdl)= (1./2.)*ytp(iy)
          u(2,2,2,2,imdl)= ypp(iy)
          call symfill(u(1,1,1,1,imdl)) 

!         u.nu.nu.nu.nu should be equal to ypp*cos(2*zeta)-ytp*sin(2*zeta)

          test1= ypp(iy)*cos2zeta-ytp(iy)*sin2zeta
          test2=dot4nu(u(1,1,1,1,imdl),nu)
          if(abs(test1-test2) > 1.d-7) print *,'****iy,test1,test2 B:',iy,test1,test2     
        enddo
!       4-psi terms
        iy=0
        do k=1,nmdl4
          imdl=imdl+1
          iy=iy+1
          u(1,1,1,1,imdl)= ypppp(iy)
          u(1,1,1,2,imdl)=-ytppp(iy)
          u(1,1,2,2,imdl)=-ypppp(iy)
          u(1,2,2,2,imdl)= ytppp(iy)
          u(2,2,2,2,imdl)= ypppp(iy)
          call symfill(u(1,1,1,1,imdl))

!         u.nu.nu.nu.nu should be equal to ypppp*cos(4*zeta)-ytppp*sin(4*zeta)

          test1= ypppp(iy)*cos4zeta-ytppp(iy)*sin4zeta
          test2=dot4nu(u(1,1,1,1,imdl),nu)
          if(abs(test1-test2) > 1.d-7) print *,'****iy,test1,test2 C:',iy,test1,test2  

        enddo

        do imdlv=1,nmdl
        do imdlu=1,nmdl
          ints(imdlv,imdlu)=ints(imdlv,imdlu) + &
              (3./8.)*dot4(u(1,1,1,1,imdlv),u(1,1,1,1,imdlu))*sintheta*dtheta*dphi/(rnorm(imdlv)*rnorm(imdlu))
        enddo
        enddo
        

      enddo
      enddo

      offmax=0.d0
      ivmax=0
      iumax=0
      do imdlv=1,nmdl
      do imdlu=1,nmdl
        if(imdlu /= imdlv) then
          test1=abs(ints(imdlv,imdlu))
        else
          test1=abs(ints(imdlv,imdlu)-1.d0)
        endif
        if(test1 > offmax) then
          offmax=test1
          ivmax=imdlv
          iumax=imdlu
        endif
      enddo
      enddo
      print *,'Maximum difference from unit matrix: ',real(offmax),' at (',ivmax,iumax,' )'
    end program testylmv4

! ------------------------------------------------
      subroutine symfill(x)
      implicit none
      double precision, dimension(2,2,2,2):: x
      x(1,1,2,1)=x(1,1,1,2)
      x(1,2,1,1)=x(1,1,1,2)
      x(1,2,1,2)=x(1,1,2,2)
      x(1,2,2,1)=x(1,1,2,2)
      x(2,1,1,1)=x(1,1,1,2)
      x(2,1,1,2)=x(1,1,2,2)
      x(2,1,2,1)=x(1,1,2,2)
      x(2,1,2,2)=x(1,2,2,2)
      x(2,2,1,1)=x(1,1,2,2)
      x(2,2,1,2)=x(1,2,2,2)
      x(2,2,2,1)=x(1,2,2,2)
      return
      end subroutine symfill

! --------------------------------------------------
      function dot4nu(x,nu)
      implicit none
      double precision dot4nu, x(2,2,2,2), nu(2)
      integer i,j,k,l
      double precision sum
      sum=0
      do i=1,2
      do j=1,2
      do k=1,2
      do l=1,2
        sum=sum+x(i,j,k,l)*nu(i)*nu(j)*nu(k)*nu(l)
      enddo
      enddo
      enddo
      enddo
      dot4nu=sum
      return
      end function dot4nu


 ! --------------------------------------------------
      function dot4(x1,x2)
      implicit none
      double precision dot4, x1(2,2,2,2), x2(2,2,2,2)
      integer i,j,k,l
      double precision sum
      sum=0
      do i=1,2
      do j=1,2
      do k=1,2
      do l=1,2
        sum=sum+x1(i,j,k,l)*x2(i,j,k,l)
      enddo
      enddo
      enddo
      enddo
      dot4=sum
      return
      end function dot4


           
